local bump = require 'bump'

local world
local player

function love.load()
world = bump.newWorld()

	-- Functions

		-- Map

	function CorridorNorth(a,b,length, broadness, t)

		for i = 1, length do


		t[#t+1] = {tile = 9, x = a,y=b+t.tilesize*i}
			for j = 1, broadness do

			t[#t+1] = {tile = 1, x = a+t.tilesize*j,y=b+t.tilesize*i, hp = 100}
			end

		t[#t+1] = {tile = 11, x = a+t.tilesize*broadness+t.tilesize,y=b+t.tilesize*i,hp = 100}
		end

		return t

	end

	function CorridorSouth(a,b,length, broadness, t)

		for i = 1, length do


		t[#t+1] = {tile = 9, x = a,y=b-t.tilesize*i,hp = 100}

			for j = 1, broadness do

			t[#t+1] = {tile = 1, x = a-t.tilesize*j,y=b-t.tilesize*i,hp = 100}

			end

		t[#t+1] = {tile = 11, x = a-t.tilesize*broadness-t.tilesize,y=b-t.tilesize*i,hp = 100}
		end

		return t

	end

	function CorridorWest(a,b,length,broadness,t)

		for i = 1, length do


		t[#t+1] = {tile = 8, y = a,x=b-t.tilesize*i,hp = 100}

			for j = 1, broadness do

			t[#t+1] = {tile = 1, y = a-t.tilesize*j,x=b-t.tilesize*i,hp = 100}

			end

		t[#t+1] = {tile = 10, y = a-t.tilesize*broadness-t.tilesize,x=b-t.tilesize*i,hp = 100}

		end

		return t

	end

	function CorridorEast(a,b,length,broadness,t)

		for i = 1, length do


		t[#t+1] = {tile = 8, y = a,x=b+t.tilesize*i,hp = 100}

			for j = 1, broadness do

			t[#t+1] = {tile = 1, y = a+t.tilesize*j,x=b+t.tilesize*i,hp = 100}

			end

		t[#t+1] = {tile = 10, y = a+t.tilesize*broadness+t.tilesize,x=b+t.tilesize*i,hp = 100}

		end

		return t

	end

	function Room(a,b,x_length,y_length,t)

	x_length = x_length + 1
	y_length = y_length + 1

		for i = 0, y_length do
			-- First row
			if i == 0 then
				for j = 0,x_length do
					if j == 0 then
					t[#t+1] = {tile = 4, x = a, y = b,hp = 100}
					elseif j == x_length then
					t[#t+1] = {tile = 5,x=a+t.tilesize*j,y=b,hp = 100}
					else
					t[#t+1] = {tile = 8,x=a+j*t.tilesize,y=b,hp = 100}
					end
				end
			elseif i == y_length then
			-- Last row
				for j = 0,x_length do
					if j == 0 then
					t[#t+1] = {tile = 6,x=a,y=b+y_length*t.tilesize,hp = 100}
					elseif j == x_length then
					t[#t+1] = {tile = 7,x=a+t.tilesize*j,y=b+y_length*t.tilesize,hp = 100}
					else
					t[#t+1] = {tile = 10,x=a+t.tilesize*j,y=b+y_length*t.tilesize,hp = 100}
					end
				end
			else
			-- Floor
				for j = 0, x_length do
					if j == 0 then
					t[#t+1] = {tile = 9,x=a,y=b+t.tilesize*i,hp = 100}
					elseif j == x_length then
					t[#t+1] = {tile = 11,x=a+t.tilesize*j,y=b+t.tilesize*i,hp = 100}
					else
					t[#t+1] = {tile = 1,x=a+t.tilesize*j,y=b+t.tilesize*i,hp = 100}
					end
				end
			end
		end

		return t

	end

	function FreeTile(a,b,ox,oy,n,t)

		for i,v in ipairs(t) do
			if v.x == b+t.tilesize*ox and v.y == a+t.tilesize*oy then
			table.remove(t,i)
			end
		end

	t[#t+1] = {tile = n, x=b+t.tilesize*ox, y=a+t.tilesize*oy,hp = 100}

		if t[#t].n ~= 1 or t[#t].n ~= 2 or t[#t].n ~= 3 then
		print(t[#t].n)
		end
		if n == 2 or n == 3 then

		t[#t].n = n

		end
	end

	-- Drawmap

	function drawMap()

		for i,v in ipairs(map) do

		local Vacuum = false
		local Color = 255
			for j, zone in ipairs(vacuum_zones) do

				if v.x-65 >= zone.x and v.x+65 <= zone.w and v.y-65 >= zone.y and v.y+65 <= zone.h then

					if zone.vacuum == true then
					Vacuum = true
					Color = zone.color
					break
					end

				end

			end

			if Vacuum then
			love.graphics.setColor(Color,Color,Color);
			else
			love.graphics.setColor(255,255,255);
			end

			if v.x >= player.x-465 and v.x <= player.x + 465 and v.y >= player.y-365 and v.y <= player.y+365 then

				if v.hp == 100 then
				love.graphics.draw(tile[v.tile], v.x, v.y)
				elseif v.hp < 100 and v.hp >= 100*(2/3) then
				love.graphics.draw(tile[v.tile], v.x, v.y)
				love.graphics.draw(tile[54], v.x, v.y)
				elseif v.hp <= 100*(2/3) and v.hp >= 100*(1/3) then
				love.graphics.draw(tile[v.tile], v.x, v.y)
				love.graphics.draw(tile[55], v.x, v.y)
				elseif v.hp <= 100*(1/3) then
				love.graphics.draw(tile[v.tile], v.x, v.y)
				love.graphics.draw(tile[56], v.x, v.y)
				end

			end

		end

	end

	-- Collision

	function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
	  return x1 < x2+w2 and
			 x2 < x1+w1 and
			 y1 < y2+h2 and
			 y2 < y1+h1
	end



	-- Variables

		-- Player

		player = {
			x = 400,
			y = 400,
			hp = 100,
			timer = 0,
			vec1 = 0,
			vec2 = 0,
			LaserTimerMax = 0.25,
			LaserTimer = 0,
			Laserready = true,
			Laser = false,
			Laser_img = love.graphics.newImage("assets/player/laser.png" ),
			Weld = false,
			w = nil,
			h = nil,
			anim = 0,
			speed = 200,
			rotSpeed = 4,
			velocity = 0,
			angle = 0,
			img_still = {img = nil, frames = nil, speed = 500},
			img_walk = {img = {}, frames = nil, speed = 10},
			img_still_laser = {img = nil, frames = nil, speed = 500},
			img_laserwalk = {img = {}, frames = nil, speed = 10},
			img_still_weld = {img = nil, frames = nil, speed = 500},
			img_weldwalk = {img = {}, frames = nil, speed = 10}}

		bullets = {}

		-- Stars

		Stars = {}

		Stars.TimerMax = 0.4
		Stars.Timer = Stars.TimerMax
		Stars.img = nil

		Star = {}

		-- Ship

		Ship = {fuel = 100,
		RightEngine = {},
		LeftEngine = {},
		speed = 0,
		compartments = {[1] = {x=100,y=100,oxygen = 100}}}

		key = {}
		key.timer = 4

	-- Texts

		Text = {false,false,false}

	-- Font

	Font = love.graphics.newFont("assets/font/font.ttf")
	Increasefont = love.graphics.newFont("assets/font/font.ttf",18)

    -- Tiles
    tile = {}

		-- Floor tiles
		for i=0,56 do -- change 3 to the number of tile images minus 1.
			tile[i] = love.graphics.newImage("assets/tiles/" .. i .. ".png" )
		end

		-- Adding tiles to bump world

	local reserved_tiles = {}

	for i,v in ipairs(tile) do

		if v.tile == 1 or v.tile == 2 or v.tile == 3 then
		reserved_tiles[#reserved_tiles+1] = {x = v.x, y = v.y}
		end

	end



    -- Map

	map = {}

	vacuum_zones = {[1] = {x=nil,y=nil,w=nil,h=nil,vacuum=false}}

	map.tilesize = 65

	Room(200,200,8,12,map)
	-- Vacuum
	vacuum_zones[1].x = 200
	vacuum_zones[1].y = 200
	vacuum_zones[1].w = 200+9*65
	vacuum_zones[1].h = 200+13*65
	vacuum_zones[1].neighbours = {3}
	vacuum_zones[1].vacuum = false
	vacuum_zones[1].color = 255
	vacuum_zones[1].oxy = 100

	Room(200+10*65,200,5,3,map)
	-- Vacuum
	vacuum_zones[#vacuum_zones+1] = {}
	vacuum_zones[#vacuum_zones].x = (200+10*65)
	vacuum_zones[#vacuum_zones].y = 200
	vacuum_zones[#vacuum_zones].w = (200+10*65)+(5+1)*65
	vacuum_zones[#vacuum_zones].h = 200+(3+1)*65
	vacuum_zones[#vacuum_zones].neighbours = {1,3}
	vacuum_zones[#vacuum_zones].vacuum = false
	vacuum_zones[#vacuum_zones].color = 255
	vacuum_zones[#vacuum_zones].oxy = 100

	Room(200+9*65,200+4*65,6,8,map)
	vacuum_zones[#vacuum_zones+1] = {}
	vacuum_zones[#vacuum_zones].x = 200+9*65
	vacuum_zones[#vacuum_zones].y = 200+4*65
	vacuum_zones[#vacuum_zones].w = (200+9*65)+(6+1)*65
	vacuum_zones[#vacuum_zones].h = (200+4*65)+(8+1)*65
	vacuum_zones[#vacuum_zones].neighbours = {1,2,4}
	vacuum_zones[#vacuum_zones].vacuum = false
	vacuum_zones[#vacuum_zones].color = 255
	vacuum_zones[#vacuum_zones].oxy = 100

	Room(200+16*65,200+3*65,4,6,map)
	vacuum_zones[#vacuum_zones+1] = {}
	vacuum_zones[#vacuum_zones].x = 200+16*65
	vacuum_zones[#vacuum_zones].y = 200+3*65
	vacuum_zones[#vacuum_zones].w = (200+16*65)+(4+1)*65
	vacuum_zones[#vacuum_zones].h = (200+3*65)+(6+1)*65
	vacuum_zones[#vacuum_zones].neighbours = {2,3}
	vacuum_zones[#vacuum_zones].vacuum = false
	vacuum_zones[#vacuum_zones].color = 255
	vacuum_zones[#vacuum_zones].oxy = 100
	-- Free tile
		-- Ship doors
	FreeTile(200,200,9,7, 3, map)
	map[#map].tileType = "Door"
	FreeTile(200,200,13,4, 2, map)
	map[#map].tileType = "Door"
	FreeTile(200,200,16,7, 3, map)
	map[#map].tileType = "Door"
		-- Ship walls
	FreeTile(200,200,9,4, 27, map)
	FreeTile(200,200,9,5, 26, map)
	FreeTile(200,200,9,6, 23, map)
	FreeTile(200,200,9,8, 21, map)
	FreeTile(200,200,9,9, 26, map)
	FreeTile(200,200,9,10, 26, map)
	FreeTile(200,200,9,11, 26, map)
	FreeTile(200,200,9,12, 26, map)
	FreeTile(200,200,9,13, 35, map)
	-- 2nd Room
	FreeTile(200,200,10,4, 30, map)
	FreeTile(200,200,11,4, 25, map)
	FreeTile(200,200,12,4, 22, map)
	FreeTile(200,200,14,4, 24, map)
	FreeTile(200,200,15,4, 25, map)
	FreeTile(200,200,16,4, 38, map)
	-- 3rd room
	FreeTile(200,200,16,3, 27, map)
	FreeTile(200,200,16,4, 45, map)
	FreeTile(200,200,16,5, 26, map)
	FreeTile(200,200,16,6, 23, map)
	FreeTile(200,200,16,8, 21, map)
	FreeTile(200,200,16,9, 26, map)
	FreeTile(200,200,16,10,33, map)
	-- Cheek filling
	FreeTile(200,200,17,0, 39, map)
	FreeTile(200,200,18,1, 39, map)
	FreeTile(200,200,19,2, 39, map)
	FreeTile(200,200,17,1, 16, map)
	FreeTile(200,200,17,2, 16, map)
	FreeTile(200,200,18,2, 16, map)

	FreeTile(200,200,17,13, 40, map)
	FreeTile(200,200,18,12, 40, map)
	FreeTile(200,200,19,11, 40, map)
	FreeTile(200,200,17,12, 16, map)
	FreeTile(200,200,17,11, 16, map)
	FreeTile(200,200,18,11, 16, map)

	-- Cockpit

	FreeTile(200,200,21,8, 47, map)
	map[#map].mode = "OnOff"
	map[#map].on = false
	map[#map].hp = 100
	map[#map].tiles = {47,48}
	map[#map].maxtile = nil
	map[#map].maxtile = math.max(map[#map].tiles[table.maxn(map[#map].tiles)])
	map[#map].timer = 2
	map[#map].text = 1
	FreeTile(200,200,21,7, 47, map)
	map[#map].mode = "OnOff"
	map[#map].on = false
	map[#map].hp = 100
	map[#map].tiles = {47,48}
	map[#map].maxtile = nil
	map[#map].maxtile = math.max(map[#map].tiles[table.maxn(map[#map].tiles)])
	map[#map].timer = 2
	map[#map].text = 2
	print(map[#map].maxtile)
	FreeTile(200,200,21,6, 49, map)
	map[#map].mode = "Throttle"
	map[#map].hp = 100
	map[#map].tiles = {49,50,51,52,53}
	map[#map].maxtile = nil
	map[#map].maxtile = math.max(map[#map].tiles[table.maxn(map[#map].tiles)])
	map[#map].text = 3

	-- Clear tiles

	for i,v in ipairs(map) do
	print(i)
	end

	for i,v in ipairs(map) do
		for j,u in ipairs(map) do
			if v.x == u.x and v.y == u.y then

				if v.tile == 1 and u.tile ~= 1 or v.tile == 2 and u.tile ~= 2 or v.tile == 3 and u.tile ~= 3 then

				print("Removed: ", v.tile, u.tile, "Nr: ", i)
				world:remove(v)
				table.remove(map,j)

				end

			end
		end

	end

	reserved = {}

	for i,v in ipairs(map) do
		if v.tile == 1 or v.tile == 2 or v.tile == 3 then
		reserved[#reserved + 1] = {x = v.x, y = v.y}
		print(i .. "tile: " .. v.tile, v.x, v.y)
		end
	end

	for i,v in ipairs(map) do


		if v.tile ~= 1 and v.tile ~= 2 and v.tile ~= 3 then
			world:add(v, v.x,v.y,65,65)
			print("added " .. i, "tile: " .. v.tile)
		end


	end



	-- Graphics

		-- Player
			-- Normal

	player.img_still.img = love.graphics.newImage("assets/player/still/1.png")

	for i = 1,4 do
	player.img_walk.img[#player.img_walk.img+1] = love.graphics.newImage("assets/player/walking/" .. i .. ".png")
	end

	player.img_walk.frames = #player.img_walk
	player.img_walk.speed = 23.2
	player.w = 54
	player.h = 54

	world:add(player, player.x, player.y, 27, 27)

		-- Heart

	player.heart = love.graphics.newImage("assets/hud/Hp.png")

			-- Laser

	player.img_still_laser.img = love.graphics.newImage("assets/player/still - Laser/1.png")

	for i = 1,4 do
	player.img_laserwalk.img[#player.img_laserwalk.img+1] = love.graphics.newImage("assets/player/walking - Laser/" .. i .. ".png")
	end

	player.img_laserwalk.frames = #player.img_walk
	player.img_laserwalk.speed = 23.2

			-- Welding

	player.img_still_weld.img = love.graphics.newImage("assets/player/still - Welding/1.png")

	for i = 1,4 do
	player.img_weldwalk.img[i] = love.graphics.newImage("assets/player/walking - welding/" .. i .. ".png")
	end

	print(player.img_weldwalk.img[1])

	player.img_weldwalk.frames = #player.img_walk
	player.img_weldwalk.speed = 23.2

	-- Sounds

	Sound = {}
	Sound[1] = {}
	Sound[#Sound] = love.audio.newSource("/assets/sounds/door_open.wav", "static")
	Sound[#Sound+1] = love.audio.newSource("/assets/sounds/ship_engine.wav", "static")
	Sound[#Sound+1] = love.audio.newSource("/assets/sounds/Machine_1on.wav", "static")
	Sound[#Sound+1] = love.audio.newSource("/assets/sounds/Machine_1off.wav", "static")
	Sound[#Sound+1] = love.audio.newSource("/assets/sounds/Laser.wav", "static")
	Sound[#Sound+1] = love.audio.newSource("/assets/sounds/vacuum_implotion.wav", "static")
	Sound[#Sound+1] = love.audio.newSource("/assets/sounds/LaserOn.wav", "static")
	Sound[#Sound+1] = love.audio.newSource("/assets/sounds/Oxygen_loss.wav", "static")
	Sound[#Sound+1] = love.audio.newSource("/assets/sounds/Weld6.wav", "static")

end

	-- Keypressed

	function love.keypressed(key)
		if key == "1" and player.hp > 0 then
		player.Laser = not player.Laser
			if player.Laser == true then
				if player.Weld == true then
				player.Weld = false
				end
			love.audio.play(Sound[7])
			end
		end

		if key == "2" and player.hp > 0 then
		player.Weld = not player.Weld
			if player.Laser == true then
			player.Laser = false
			end
		end
	end
	-- Update

	tx = 0
	ty = 0
	xy = 0

	function angle(x1, y1, x2, y2)
	return math.atan2(y2-y1, x2-x1)
	end

	function screenToWorld(sx,sy)
	  return sx-tx,sy-ty
	end

	function worldToScreen(wx,wy)
	return wx+tx,wy+ty
	end

function love.update( dt )

	-- Ship

	if key.timer > 0 then
	key.timer = key.timer - 0.1
	end

	if Ship.speed > 0 then
	Sound[2]:play()
	Sound[2]:setPitch(Ship.speed/100)
	else
	Sound[2]:stop()
	end

	--print(math.floor((player.x)/65)-2,math.floor((player.y)/65)-2)
	player.velocity = 0

	-- Variable update

	map_x = player.x
	map_y = player.y

   -- Player input

	if love.keyboard.isDown("w") and player.hp > 0 then
	player.velocity = player.speed
	elseif love.keyboard.isDown("s") and player.hp > 0 then
	player.velocity = -player.speed
	end

	if love.keyboard.isDown("d") and player.hp > 0 then
		player.angle = player.angle + player.rotSpeed * dt
		if player.angle > math.pi*2 and player.hp > 0 then
		player.angle = 0
		end
	elseif love.keyboard.isDown("a")  and player.hp > 0 then
		player.angle = player.angle - player.rotSpeed * dt
		if player.angle < 0 then
		player.angle = math.pi*2
		end
	end

	-- Movement update
	player.x = player.x + math.cos(player.angle) * player.velocity * dt
	player.y = player.y + math.sin(player.angle) * player.velocity * dt

    if love.keyboard.isDown( "escape" ) then
        love.event.quit()
    end

	-- Bullets

	player.LaserTimer = player.LaserTimer - (1 * dt)
	if player.LaserTimer < 0 then
	  player.Laserready = true
	end

		-- Player
	local laser = false
		if love.keyboard.isDown('rctrl', 'lctrl', 'ctrl') and player.Laserready and player.Laser and player.hp > 0 or
		love.mouse.isDown("l") and player.Laserready and player.Laser and player.hp > 0 then
		-- Create some bullets
		newBullet = {
		x = player.x + math.cos(player.angle) * 100 * dt,
		y = player.y + math.sin(player.angle) * 100 * dt,
		speedX =  math.cos(player.angle) * 1800 * dt,
		speedY = math.sin(player.angle) * 1800 * dt,
		angle = player.angle,
		img = player.Laser_img}

		table.insert(bullets, newBullet)
		player.Laserready = false
		player.LaserTimer = player.LaserTimerMax

		love.audio.play(Sound[5])

	end

	if love.mouse.isDown("l") and player.Weld and player.hp > 0 then
	love.audio.play(Sound[9])

	-- Create some bullets
		newBullet = {
		x = player.x + math.cos(player.angle) * 100 * dt,
		y = player.y + math.sin(player.angle) * 100 * dt,
		speedX =  math.cos(player.angle) * 1800 * dt,
		speedY = math.sin(player.angle) * 1800 * dt,
		angle = player.angle,
		img = player.weld_img}

		table.insert(bullets, newBullet)
		player.Laserready = false
		player.LaserTimer = player.LaserTimerMax

		love.audio.play(Sound[5])

	elseif not love.mouse.isDown("l") and player.Weld and player.hp > 0 then
	love.audio.stop(Sound[9])
	end

	for i, bullet in ipairs(bullets) do
		bullet.x = bullet.x + bullet.speedX
		bullet.y = bullet.y + bullet.speedY
	end

	-- Vacuum zones

	for i,v in ipairs(vacuum_zones) do

		if v.vacuum == true then

			if v.oxy > 69 then
			v.oxy = v.oxy - 0.1
			Sound[8]:setVolume(1-(100/v.color))
			love.audio.play(Sound[8])
--
				if v.color > 97.6749999999992 then
				v.color = v.color - 0.75
				elseif love.keyboard.isDown("k") then
				v.color = v.color - 1
				elseif love.keyboard.isDown("i") then
				v.color = v.color + 1
				end

			break

			end

		end

	end

	-- Collisions

	for i,v in ipairs(map) do

		for j, bullet in ipairs(bullets) do
			if CheckCollision(bullet.x,bullet.y,12,5,v.x,v.y,map.tilesize,map.tilesize) then
				if v.tile ~= 1 or v.hp > 0 and v.tile ~= 1 then
					if v.hp > 0 then
					v.hp = v.hp - 100/6
					end
					if v.hp < 100 and v.hp > 100*(2/3) then
					--v.tile = 54
					elseif v.hp < 100*(2/3) and v.hp > 100*(1/3) then
					--v.tile = 55
					elseif v.hp < 100*(1/3) and v.hp > 0 then
					--v.tile = 56

					end
				table.remove(bullets,j)
				end
			end
		end

		-- Vacuum

		if v.hp <= 100*(1/3) then

					for j, zone in ipairs(vacuum_zones) do

						if v.x >= zone.x and v.x <= zone.w and v.y >= zone.y and v.y <= zone.h then

							if player.x >= zone.x and player.x <= zone.w and player.y >= zone.y and player.y <= zone.h then

							if zone.vacuum == true then
								player.timer = player.timer + 1

								if player.timer > 78 then
								player.timer = 0
									if player.hp > 0 then
									player.hp = player.hp - (100/10)
									end
								end
							end

								if zone.vacuum == true then
									for k, current_room in ipairs(vacuum_zones) do
										if v.x >= current_room.x and v.x <= current_room.w and
										v.y >= current_room.y and v.y <= current_room.h then

											if player.x >= current_room.x and player.x <= current_room.w and
											player.y >= current_room.y and player.y <= current_room.h then
											else
												if current_room.vacuum == false then
												current_room.vacuum = true
												Sound[6]:play()
												break
												end
											end
										end
									end
								end
							else
								if zone.vacuum == true then
									for k, current_room in ipairs(vacuum_zones) do
										if v.x >= current_room.x and v.x <= current_room.w and
										v.y >= current_room.y and v.y <= current_room.h then

											if player.x >= current_room.x and player.x <= current_room.w and
											player.y >= current_room.y and player.y <= current_room.h and current_room.vacuum ~= true then
											current_room.vacuum = true
											Sound[6]:play()
											break
											end
										end
									end
								end
							end

						end

						if v.x >= zone.x and v.x <= zone.w and v.y >= zone.y and v.y <= zone.h then
						local Zones = 0

							for k, subZone in ipairs(vacuum_zones) do
								if v.x >= subZone.x and v.x <= subZone.w and v.y >= subZone.y and v.y <= subZone.h then
								Zones = Zones + 1
								end
							end

								if Zones == 1 then
								local implotion = false
								local vacuum = {true,true,true,true,true,true,true,true}

									for k, savior in ipairs(map) do

										if v.x+65 == savior.x and v.y == savior.y then
										--print("Right")
										vacuum[1] = false
										end

									end

									for k, savior in ipairs(map) do

										if v.x+65 == savior.x and v.y+65 == savior.y then
										--print("Right Down")
										vacuum[2] = false
										end

									end

									for k, savior in ipairs(map) do

										if v.x == savior.x and v.y+65 == savior.y then
										--print("Under")
										vacuum[3] = false
										end

									end

									for k, savior in ipairs(map) do

										if v.x-65 == savior.x and v.y+65 == savior.y then
										--print("UnderLeft")
										vacuum[4] = false
										end

									end

									for k, savior in ipairs(map) do

										if v.x-65 == savior.x and v.y == savior.y then
										--print("Left")
										vacuum[5] = false
										end

									end

									for k, savior in ipairs(map) do

										if v.x-65 == savior.x and v.y-65 == savior.y then
										--print("Left Up")
										vacuum[6] = false
										end

									end

									for k, savior in ipairs(map) do

										if v.x == savior.x and v.y-65 == savior.y then
										--print("Up")
										vacuum[7] = false
										end

									end

									for k, savior in ipairs(map) do

										if v.x+65 == savior.x and v.y-65 == savior.y then
										--print("Right Up")
										vacuum[8] = false
										end

									end

									for I = 1, #vacuum do

										if vacuum[I] == true and zone.vacuum == false then
										zone.vacuum = true
										Sound[6]:play()
										end

									end

								end
						end

					end

		end

		if v.timer ~= nil then
		v.timer = v.timer - 0.2
		end

		if v.tileType == "Door" then

			if CheckCollision(player.x,player.y,player.w,player.h,v.x,v.y,map.tilesize,map.tilesize) and love.keyboard.isDown("w") and v.tile ~= 1 then
			love.audio.play(Sound[1])
			v.tile = 1
			elseif CheckCollision(player.x,player.y,player.w,player.h,v.x,v.y,map.tilesize,map.tilesize) then
			v.tile = 1
			else
			v.tile = v.n
			end

		end

		if v.mode == "OnOff" then
			if CheckCollision(player.x,player.y,player.w,player.h,v.x,v.y,map.tilesize,map.tilesize) and love.keyboard.isDown(" ") and v.timer < 0 then
			v.on = not v.on
			v.timer = 2
				if v.on == true then
				love.audio.play(Sound[3])
				v.tile = v.maxtile
				elseif v.on == false then
				love.audio.play(Sound[4])
				v.tile = v.maxtile-1
				end

			end
		end

		if v.mode == "Throttle" then
			if CheckCollision(player.x,player.y,player.w,player.h,v.x,v.y,map.tilesize,map.tilesize) then
			Text[v.text] = true
				if love.keyboard.isDown("up") then
					if Ship.speed < 200 then
					Ship.speed = Ship.speed + 1
					end
				elseif love.keyboard.isDown("down") then
					if Ship.speed > 0 then
					Ship.speed = Ship.speed - 1
					end
				end

				if Ship.speed < 1 then
				v.tile = v.tiles[1]
				elseif Ship.speed > 0 and Ship.speed < 25*2 then
				v.tile = v.tiles[2]
				elseif Ship.speed >= 25*2 and Ship.speed < 50*2 then
				v.tile = v.tiles[3]
				elseif Ship.speed >= 50*2 and Ship.speed < 75*2 then
				v.tile = v.tiles[4]
				elseif Ship.speed >= 75*2 then
				v.tile = v.tiles[5]
				end
			else
			Text[v.text] = false
			end
		end

	end

	-- Star creation
	if Ship.speed > 0 then
		Stars.Timer = Stars.Timer - (0.6/(100/Ship.speed) * dt)
		if Stars.Timer < 0 then
			Stars.Timer = Stars.TimerMax

			-- Create an enemy
			randomNumber = math.random(10, love.graphics.getHeight() - 10)
			newStar = {}
			newStar = {x = 1200, y = randomNumber,radius = math.random(1,100), segment = 25}
			table.insert(Star, newStar)

		end
	end

		-- Positions
	local stars = 0
	for i,v in ipairs(Star) do
	stars = i
	end

	for i, stars in ipairs(Star) do
		stars.x = stars.x - (3*(Ship.speed/25))
		if stars.x < -200 then -- remove enemies when they pass off the screen
			table.remove(Star, i)
		end

	end

		-- Player collision

	local newX, newY, cols, len = world:move(player, player.x, player.y)
	player.x, player.y = newX, newY


end

function love.draw()

	-- Stars

	local stars = 0
	for i,v in ipairs(Star) do
	stars = i
	end

	for i, stars in ipairs(Star) do
	love.graphics.setColor(255, 255, 255);
	love.graphics.circle("fill", stars.x, stars.y, stars.radius,stars.segment)
	end

	-- Drawing

	tx = -player.x + 400-32.5
	ty = -player.y + 300
	if player.hp > 0 then
	mx = love.mouse.getX() -- mouse coordinates on screen
	my = love.mouse.getY()
	wx,wy = screenToWorld(mx,my) -- calculate position of the mouse in "world coordinates"
	angleBetweenPlayerAndMouse = angle(player.x,player.y,wx,wy) -- calculate angle
	player.angle = angleBetweenPlayerAndMouse
	end
	love.graphics.translate(tx,ty)

	drawMap()

	love.graphics.setColor(255, 255, 255);

	-- Laser

	for i, bullet in ipairs(bullets) do
	love.graphics.draw(bullet.img, bullet.x, bullet.y, bullet.angle,1,1,-7,-2)
	end

	-- Texts

	for i,v in ipairs(Text) do
		if v == true then
		love.graphics.setFont(Increasefont);
		love.graphics.setColor(255, 255, 255)
		love.graphics.print("Increase Throttle ('Up')" .. "\n" .. "Decrease Throttle ('Down')", player.x-32.5-40, player.y+250)
		end
	end

	-- Player

		if love.keyboard.isDown("w") then
		player.anim = player.anim + 1
		elseif love.keyboard.isDown("s") then
		player.anim = player.anim - 1
		else
		player.anim = 0
		end

	love.graphics.draw(player.heart, player.x-400+62, player.y-300+24)
	love.graphics.setFont(Font);
	love.graphics.print(player.hp .. "%", player.x-400+138, player.y-265)

		if player.hp > 0 then

			if player.Laser == true then

				if love.keyboard.isDown("s") and player.anim == -1 then
				player.anim = player.img_walk.speed*5
				end

				if player.anim > -1 and player.anim < player.img_walk.speed and love.keyboard.isDown("w")
				or player.anim > -1 and player.anim < player.img_walk.speed and love.keyboard.isDown("s") then

				love.graphics.draw(player.img_laserwalk.img[1],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)

				elseif player.anim > player.img_walk.speed-1 and player.anim < player.img_walk.speed*2+1 and love.keyboard.isDown("w")
				or player.anim > player.img_walk.speed-1 and player.anim < player.img_walk.speed*2+1 and love.keyboard.isDown("s") then
				love.graphics.draw(player.img_laserwalk.img[2],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)

				elseif player.anim > player.img_laserwalk.speed*2-1 and player.anim < player.img_walk.speed*3+1 and love.keyboard.isDown("w")
				or player.anim > player.img_laserwalk.speed*2-1 and player.anim < player.img_walk.speed*3+1 and love.keyboard.isDown("s")then
				love.graphics.draw(player.img_laserwalk.img[3],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)

				elseif player.anim > player.img_walk.speed*3-1 and player.anim < player.img_walk.speed*4+1 and love.keyboard.isDown("w")
				or player.anim > player.img_walk.speed*3-1 and player.anim < player.img_walk.speed*4+1 and love.keyboard.isDown("s") then

				love.graphics.draw(player.img_laserwalk.img[4],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)

				elseif player.anim > player.img_walk.speed*4-1 and player.anim < player.img_walk.speed*5+1 and love.keyboard.isDown("w")
				or player.anim > player.img_walk.speed*4-1 and player.anim < player.img_walk.speed*5+1 and love.keyboard.isDown("s")then

				love.graphics.draw(player.img_laserwalk.img[4],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)

					if love.keyboard.isDown("w") then
					player.anim = 0
					end

				end

			elseif player.Weld == true then

				if love.keyboard.isDown("s") and player.anim == -1 then
				player.anim = player.img_walk.speed*5
				end

				if player.anim > -1 and player.anim < player.img_walk.speed and love.keyboard.isDown("w")
				or player.anim > -1 and player.anim < player.img_walk.speed and love.keyboard.isDown("s") then

				love.graphics.draw(player.img_weldwalk.img[1],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)

				elseif player.anim > player.img_walk.speed-1 and player.anim < player.img_walk.speed*2+1 and love.keyboard.isDown("w")
				or player.anim > player.img_walk.speed-1 and player.anim < player.img_walk.speed*2+1 and love.keyboard.isDown("s") then
				love.graphics.draw(player.img_weldwalk.img[2],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)

				elseif player.anim > player.img_weldwalk.speed*2-1 and player.anim < player.img_walk.speed*3+1 and love.keyboard.isDown("w")
				or player.anim > player.img_weldwalk.speed*2-1 and player.anim < player.img_walk.speed*3+1 and love.keyboard.isDown("s")then
				love.graphics.draw(player.img_weldwalk.img[3],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)

				elseif player.anim > player.img_walk.speed*3-1 and player.anim < player.img_walk.speed*4+1 and love.keyboard.isDown("w")
				or player.anim > player.img_walk.speed*3-1 and player.anim < player.img_walk.speed*4+1 and love.keyboard.isDown("s") then

				love.graphics.draw(player.img_weldwalk.img[4],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)

				elseif player.anim > player.img_walk.speed*4-1 and player.anim < player.img_walk.speed*5+1 and love.keyboard.isDown("w")
				or player.anim > player.img_walk.speed*4-1 and player.anim < player.img_walk.speed*5+1 and love.keyboard.isDown("s")then

				love.graphics.draw(player.img_weldwalk.img[4],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)

					if love.keyboard.isDown("w") then
					player.anim = 0
					end

				end

			elseif player.Laser == false and player.Weld == false then

				if player.anim >= 0 and player.anim < player.img_walk.speed and love.keyboard.isDown("w") then
				love.graphics.draw(player.img_walk.img[1],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)
				elseif player.anim > player.img_walk.speed-1 and player.anim < player.img_walk.speed*2+1 and love.keyboard.isDown("w") then
				love.graphics.draw(player.img_walk.img[2],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)
				elseif player.anim > player.img_walk.speed*2-1 and player.anim < player.img_walk.speed*3+1 and love.keyboard.isDown("w") then
				love.graphics.draw(player.img_walk.img[3],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)
				elseif player.anim > player.img_walk.speed*3-1 and player.anim < player.img_walk.speed*4+1 and love.keyboard.isDown("w") then
				love.graphics.draw(player.img_walk.img[4],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)
				elseif player.anim > player.img_walk.speed*4-1 and player.anim < player.img_walk.speed*5+1 and love.keyboard.isDown("w") then
				love.graphics.draw(player.img_walk.img[4],player.x,player.y, player.angle,1,1,player.w/2,player.h/2)
				player.anim = 0
				end

			end

			if not love.keyboard.isDown("w") and not love.keyboard.isDown("s") and player.Laser == true and player.hp > 0 then
			love.graphics.draw(player.img_still_laser.img, player.x, player.y, player.angle,1,1,player.w/2,player.h/2)
			elseif not love.keyboard.isDown("w") and not love.keyboard.isDown("s") and player.Weld == true and player.hp > 0 then
			love.graphics.draw(player.img_still_weld.img, player.x, player.y, player.angle,1,1,player.w/2,player.h/2)
			elseif not love.keyboard.isDown("w") and not love.keyboard.isDown("s") then
			love.graphics.draw(player.img_still.img, player.x, player.y, player.angle,1,1,player.w/2,player.h/2)
			end

		end





end
